    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------
    028     * DateTick.java
    029     * -------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   Peter Kolb (patch 1934255);
    034     *                   Andrew Mickish (patch 1870189);
    035     *
    036     * Changes
    037     * -------
    038     * 07-Nov-2003 : Version 1 (DG);
    039     * 13-May-2004 : Added equals() method (DG);
    040     * 25-Sep-2008 : Added minor tick support, see patch 1934255 by Peter Kolb (DG);
    041     *
    042     */
    043
    044    package org.jfree.chart.axis;
    045
    046    import java.util.Date;
    047
    048    import org.jfree.ui.TextAnchor;
    049    import org.jfree.util.ObjectUtilities;
    050
    051    /**
    052     * A tick used by the {@link DateAxis} class.
    053     */
    054    public class DateTick extends ValueTick {
    055
    056        /** The date. */
    057        private Date date;
    058
    059        /**
    060         * Creates a new date tick.
    061         *
    062         * @param date  the date.
    063         * @param label  the label.
    064         * @param textAnchor  the part of the label that is aligned to the anchor
    065         *                    point.
    066         * @param rotationAnchor  defines the rotation point relative to the text.
    067         * @param angle  the rotation angle (in radians).
    068         */
    069        public DateTick(Date date, String label,
    070                        TextAnchor textAnchor, TextAnchor rotationAnchor,
    071                        double angle) {
    072
    073            this(TickType.MAJOR, date, label, textAnchor, rotationAnchor, angle);
    074
    075        }
    076
    077        /**
    078         * Creates a new date tick.
    079         *
    080         * @param tickType the tick type.
    081         * @param date  the date.
    082         * @param label  the label.
    083         * @param textAnchor  the part of the label that is aligned to the anchor
    084         *                    point.
    085         * @param rotationAnchor  defines the rotation point relative to the text.
    086         * @param angle  the rotation angle (in radians).
    087         *
    088         * @since 1.0.12
    089         */
    090        public DateTick(TickType tickType, Date date, String label,
    091                        TextAnchor textAnchor, TextAnchor rotationAnchor,
    092                        double angle) {
    093
    094            super(tickType, date.getTime(), label, textAnchor, rotationAnchor, angle);
    095            this.date = date;
    096
    097        }
    098
    099        /**
    100         * Returns the date.
    101         *
    102         * @return The date.
    103         */
    104        public Date getDate() {
    105            return this.date;
    106        }
    107
    108        /**
    109         * Tests this tick for equality with an arbitrary object.
    110         *
    111         * @param obj  the object to test (<code>null</code> permitted).
    112         *
    113         * @return A boolean.
    114         */
    115        public boolean equals(Object obj) {
    116            if (obj == this) {
    117                return true;
    118            }
    119            if (!(obj instanceof DateTick)) {
    120                return false;
    121            }
    122            DateTick that = (DateTick) obj;
    123            if (!ObjectUtilities.equal(this.date, that.date)) {
    124                return false;
    125            }
    126            return super.equals(obj);
    127        }
    128
    129        /**
    130         * Returns a hash code for this object.
    131         *
    132         * @return A hash code.
    133         */
    134        public int hashCode() {
    135            return this.date.hashCode();
    136        }
    137
    138    }